package com.lzmispt.data.resource.service.file.impl;

package .tmp;

import com.alibaba.csp.sentinel.util.StringUtil;
import com.alibaba.fastjson.JSON;
import com.lzmispt.data.center.entity.dto.databasestruct.DBColumnDTO;
import com.lzmispt.data.center.entity.dto.databasestruct.DataSourceDTO;
import com.lzmispt.data.center.entity.dto.log.ErrorLogDTO;
import com.lzmispt.data.center.entity.dto.log.LogDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.MetadataEntityDataItemDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.MetadataTypeParamDTO;
import com.lzmispt.data.center.entity.enums.FileSysFieldEnum;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.datasource.DataSourceVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityDataItemVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataTypeVO;
import com.lzmispt.data.resource.client.DataInterfaceClient;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.dao.file.IFileInfoFieldDao;
import com.lzmispt.data.resource.dao.file.IFileInfoTableDao;
import com.lzmispt.data.resource.entity.dto.file.ImportFileInfoFieldParamDTO;
import com.lzmispt.data.resource.entity.dto.file.ImportFileInfoFieldToEntityParamDTO;
import com.lzmispt.data.resource.entity.po.file.FileInfoFieldPO;
import com.lzmispt.data.resource.entity.po.file.FileInfoTablePO;
import com.lzmispt.data.resource.service.file.IFileInfoFieldSync;
import com.lzmispt.data.resource.service.file.impl.FileInfoFieldManager;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.database.IManage;
import com.lzmispt.dcbase.databasestruct.DataStructProvider;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.log.DCLogHelper;
import com.lzmispt.dcbase.sysfield.SysFieldHelper;
import com.lzmispt.dcbase.util.StringUtil;
import com.lzmispt.framework.entity.entity.ResultEntity;
import com.lzmispt.framework.exception.ExceptionUtil;
import com.lzmispt.framework.log.LogHelper;
import com.lzmispt.framework.utils.WorkerId;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Collectors;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

public abstract class FileInfoFieldSyncManager implements IFileInfoFieldSync, IManage {
  private static String DEFAULT_SCHEMA = "dbo";
  
  private static int NAME_MAX_LENGTH = 10;
  
  private static final int GUID_LENGTH = 36;
  
  private static final int SNOWFLAKE_LENGTH = 20;
  
  @Autowired
  DataStandardClient dataStandardClient;
  
  @Autowired
  DataInterfaceClient dataInterfaceClient;
  
  public ResultEntity<String> importFileInfoFieldToFileTable(ImportFileInfoFieldToEntityParamDTO fileInfoFieldToEntityParamDTO, String tokenId) {
    ResultEntity<String> result = null;
    ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO = new ImportFileInfoFieldParamDTO();
    BeanUtils.copyProperties(fileInfoFieldToEntityParamDTO, importFileInfoFieldParamDTO);
    importFileInfoFieldParamDTO.setIsImportTable(Integer.valueOf(0));
    FileInfoTablePO fileInfoTablePO = ((IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(importFileInfoFieldParamDTO.getPlatCode(), IFileInfoTableDao.class)).selectFileInfoTable(importFileInfoFieldParamDTO.getEntityId());
    importFileInfoFieldParamDTO.setTempFileInfoTable(fileInfoTablePO);
    result = importFileInfoField(importFileInfoFieldParamDTO, tokenId);
    StringBuilder logBuilder = new StringBuilder();
    List<FileInfoFieldPO> fileInfoFieldSendList = new ArrayList<>();
    List<FileInfoFieldPO> fileInfoFieldPOS = ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(fileInfoFieldToEntityParamDTO.getPlatCode(), IFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileInfoTablePO.getFileTableId());
    if (fileInfoTablePO != null) {
      String entityName = fileInfoTablePO.getFileTableName();
      Map<String, Integer> fields = fileInfoFieldToEntityParamDTO.getImportFieldList();
      Set<String> keys = fields.keySet();
      for (String key : keys) {
        if (logBuilder.length() == 0) {
          logBuilder.append("导入字段  文件表【" + entityName + "】从数据表【" + fileInfoFieldToEntityParamDTO.getTableName() + "】中导入字段 【" + key);
        } else {
          logBuilder.append("," + key);
        } 
        for (FileInfoFieldPO fileInfoFieldPO : fileInfoFieldPOS) {
          if (fileInfoFieldPO.getFieldName().equalsIgnoreCase(key))
            fileInfoFieldSendList.add(fileInfoFieldPO); 
        } 
      } 
      logBuilder.append("】");
      LogDTO logDTO = new LogDTO();
      logDTO.setMsg(logBuilder.toString());
      logDTO.setPlatCode(fileInfoFieldToEntityParamDTO.getPlatCode());
      logDTO.setTokenId(tokenId);
      DCLogHelper.system(logDTO);
    } 
    if (result != null && !result.getCode().equals(Integer.valueOf(0)))
      return result; 
    ((FileInfoFieldManager)ServiceUtil.getFileInfoFieldManager(getDefaultCode(), FileInfoFieldManager.class)).sendSyncInformationToDBMsg(fileInfoFieldPOS, fileInfoFieldToEntityParamDTO.getTokenId());
    return ResultEntity.successMessage(null);
  }
  
  public ResultEntity importFileInfoField(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, String tokenId) {
    StringBuilder errorSbStr = new StringBuilder();
    List<FileInfoFieldPO> insertFileInfoFieldPOList = new ArrayList<>();
    List<FileInfoFieldPO> updateFileInfoFieldPOList = new ArrayList<>();
    List<MetadataEntityDataItemVO> insertMetadataEntityDataItemList = new ArrayList<>();
    List<MetadataEntityDataItemVO> updateMetadataEntityDataItemList = new ArrayList<>();
    List<FileInfoFieldPO> insertAllFileInfoFieldList = new ArrayList<>();
    List<FileInfoFieldPO> updateAllFileInfoFieldList = new ArrayList<>();
    List<MetadataEntityDataItemVO> insertAllMetadataEntityDataItemList = new ArrayList<>();
    List<MetadataEntityDataItemVO> updateAllMetadataEntityDataItemList = new ArrayList<>();
    FileInfoTablePO masterFileInfoTablePO = null;
    importFileInfoFieldParamDTO.setTokenId(tokenId);
    try {
      IFileInfoTableDao fileInfoTableDao = (IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(getDefaultCode(), IFileInfoTableDao.class);
      masterFileInfoTablePO = fileInfoTableDao.selectFileInfoTable(importFileInfoFieldParamDTO.getEntityId());
      if (masterFileInfoTablePO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_FILE_INFO_TABLE_NO_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_FILE_INFO_TABLE_NO_EXISTS.getMessage()); 
      DataSourceVO dataSourceVO = getDataSourcePO(importFileInfoFieldParamDTO);
      if (dataSourceVO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_SOURCE_GET_DATASOURCE_BY_ID_FAILED.getCode()), StatusCodeEnum.DATA_SOURCE_GET_DATASOURCE_BY_ID_FAILED
            .getMessage()); 
      ResultEntity<DataStructProvider> getDataBaseProviderRet = getDataStructProvider(dataSourceVO, importFileInfoFieldParamDTO);
      if (!getDataBaseProviderRet.getCode().equals(Integer.valueOf(0)))
        return ResultEntity.errorMessage(getDataBaseProviderRet.getCode(), getDataBaseProviderRet.getMsg()); 
      ResultEntity isExistTable = isExistTable((DataStructProvider)getDataBaseProviderRet.getObj(), dataSourceVO, masterFileInfoTablePO.getFileTableName());
      if (isExistTable != null)
        return isExistTable; 
      ResultEntity<Map<String, Object>> importInfoItemsRet = importFileInfoFields(masterFileInfoTablePO, importFileInfoFieldParamDTO, (DataStructProvider)getDataBaseProviderRet.getObj(), dataSourceVO, errorSbStr);
      if (!importInfoItemsRet.getCode().equals(Integer.valueOf(0)))
        return importInfoItemsRet; 
      Map<String, Object> resultMap = (Map<String, Object>)importInfoItemsRet.getObj();
      insertFileInfoFieldPOList = (List<FileInfoFieldPO>)resultMap.get("insertFileInfoFieldList");
      updateFileInfoFieldPOList = (List<FileInfoFieldPO>)resultMap.get("updateFileInfoFieldList");
      insertMetadataEntityDataItemList = (List<MetadataEntityDataItemVO>)resultMap.get("insertMetadataEntityDataItemList");
      updateMetadataEntityDataItemList = (List<MetadataEntityDataItemVO>)resultMap.get("updateMetadataEntityDataItemList");
      insertAllFileInfoFieldList = (List<FileInfoFieldPO>)resultMap.get("insertAllFileInfoFieldList");
      updateAllFileInfoFieldList = (List<FileInfoFieldPO>)resultMap.get("updateAllFileInfoFieldList");
      insertAllMetadataEntityDataItemList = (List<MetadataEntityDataItemVO>)resultMap.get("insertAllMetadataEntityDataItemList");
      updateAllMetadataEntityDataItemList = (List<MetadataEntityDataItemVO>)resultMap.get("updateAllMetadataEntityDataItemList");
      errorSbStr = (StringBuilder)resultMap.get("errorSbStr");
      if (!StringUtils.isEmpty(errorSbStr.toString()))
        if (Objects.equals(DCConst.TRUE, importFileInfoFieldParamDTO.getIsImportTable())) {
          recoverAllErrorData(importFileInfoFieldParamDTO, insertAllFileInfoFieldList, updateAllFileInfoFieldList, insertAllMetadataEntityDataItemList, updateAllMetadataEntityDataItemList, masterFileInfoTablePO, tokenId);
        } else {
          recoverFileInfoFieldAndDataItemErrorData(insertFileInfoFieldPOList, updateFileInfoFieldPOList, insertMetadataEntityDataItemList, updateMetadataEntityDataItemList, importFileInfoFieldParamDTO, masterFileInfoTablePO, tokenId);
        }  
    } catch (Exception ex) {
      recoverAllErrorData(importFileInfoFieldParamDTO, insertAllFileInfoFieldList, updateAllFileInfoFieldList, insertAllMetadataEntityDataItemList, updateAllMetadataEntityDataItemList, masterFileInfoTablePO, tokenId);
      return importFileInfoFieldException(importFileInfoFieldParamDTO, tokenId, ExceptionUtil.getStackTraceMsg(ex));
    } 
    if (StringUtils.hasText(errorSbStr.toString()))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_IMPORT_FILE_INFO_FIELD_BY_COL_FAILED.getCode()), errorSbStr.toString()); 
    return ResultEntity.successMessage(masterFileInfoTablePO.getFileTableId());
  }
  
  private ResultEntity<Map<String, Object>> importFileInfoFields(FileInfoTablePO masterEntity, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, DataStructProvider dataStructProvider, DataSourceVO dataSourceVO, StringBuilder errorSbStr) {
    Map<String, Object> resultMap = new HashMap<>();
    List<FileInfoFieldPO> insertFileInfoFieldList = new ArrayList<>();
    List<FileInfoFieldPO> updateFileInfoFieldList = new ArrayList<>();
    List<MetadataEntityDataItemVO> insertMetadataEntityDataItemList = new ArrayList<>();
    List<MetadataEntityDataItemVO> updateMetadataEntityDataItemList = new ArrayList<>();
    List<FileInfoFieldPO> insertAllFileInfoFieldList = new ArrayList<>();
    List<FileInfoFieldPO> updateAllFileInfoFieldList = new ArrayList<>();
    List<MetadataEntityDataItemVO> insertAllMetadataEntityDataItemList = new ArrayList<>();
    List<MetadataEntityDataItemVO> updateAllMetadataEntityDataItemList = new ArrayList<>();
    FileInfoFieldPO tempFileInfoField = null;
    MetadataEntityDataItemVO tempDataItem = null;
    int inEntityOrder = ((Integer)((FileInfoFieldManager)ServiceUtil.getFileInfoFieldManager(getDefaultCode(), FileInfoFieldManager.class)).getNewFileInfoFieldOrder(masterEntity.getFileTableId()).getObj()).intValue();
    IFileInfoFieldDao fileInfoFieldDao = (IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(getDefaultCode(), IFileInfoFieldDao.class);
    List<FileInfoFieldPO> fileInfoFieldPOList = fileInfoFieldDao.selectFileInfoFieldsByFileTableId(masterEntity.getFileTableId());
    List<Long> dataItemIds = (List<Long>)fileInfoFieldPOList.stream().map(m -> m.getDataItemId()).collect(Collectors.toList());
    List<MetadataEntityDataItemVO> metadataEntityDataItemPOList = CollectionUtils.isEmpty(dataItemIds) ? new ArrayList<>() : (List<MetadataEntityDataItemVO>)this.dataStandardClient.getMetadataEntityDataItemByIds(dataItemIds, importFileInfoFieldParamDTO.getPlatCode(), importFileInfoFieldParamDTO.getTokenId()).getObj();
    ResultEntity<List<DBColumnDTO>> getColumnDTOListRet = getColumnDTOList(importFileInfoFieldParamDTO, dataStructProvider, dataSourceVO);
    if (!getColumnDTOListRet.getCode().equals(Integer.valueOf(0)))
      return ResultEntity.errorMessage(getColumnDTOListRet.getCode(), getColumnDTOListRet.getMsg()); 
    List<DBColumnDTO> dbColumnDTOList = (List<DBColumnDTO>)getColumnDTOListRet.getObj();
    List<String> errorFields = new ArrayList<>();
    List<String> failFields = new ArrayList<>(importFileInfoFieldParamDTO.getImportFieldList().keySet());
    List<MetadataEntityDataItemDTO> addMetadataEntityDataItemDTOList = new ArrayList<>();
    initStandardClientWorkerIdList(importFileInfoFieldParamDTO, dbColumnDTOList.size());
    ResultEntity<Map<String, Object>> addInfoItemAndDataItemRet = null;
    for (int i = 0; i < dbColumnDTOList.size(); i++) {
      Boolean isAddFileInfoField = Boolean.valueOf(true);
      Boolean isAddDataItem = Boolean.valueOf(true);
      DBColumnDTO dbColumnDTO = dbColumnDTOList.get(i);
      try {
        if (isNeedImport(importFileInfoFieldParamDTO, dbColumnDTO)) {
          if (!failFields.isEmpty() && importFileInfoFieldParamDTO.getImportFieldList().containsKey(dbColumnDTO.getColumnName()))
            failFields.remove(dbColumnDTO.getColumnName()); 
          addInfoItemAndDataItemRet = getAddFileInfoFieldAndDataItem(dbColumnDTO, importFileInfoFieldParamDTO, dataSourceVO, fileInfoFieldPOList, metadataEntityDataItemPOList);
          if (!addInfoItemAndDataItemRet.getCode().equals(Integer.valueOf(0)))
            return addInfoItemAndDataItemRet; 
          Map<String, Object> retMap = (Map<String, Object>)addInfoItemAndDataItemRet.getObj();
          tempFileInfoField = (FileInfoFieldPO)retMap.get("tempFileInfoField");
          tempDataItem = (MetadataEntityDataItemVO)retMap.get("tempDataItem");
          Map<String, Object> result = saveFileInfoFieldFromImport(tempFileInfoField, dbColumnDTO, Integer.valueOf(inEntityOrder), importFileInfoFieldParamDTO, masterEntity, tempDataItem, addMetadataEntityDataItemDTOList);
          isAddFileInfoField = (Boolean)result.get("isAddFileInfoField");
          isAddDataItem = (Boolean)result.get("isAddDataItem");
          inEntityOrder = ((Integer)result.get("inEntityOrder")).intValue();
          recordRollBackItems(tempFileInfoField, tempDataItem, isAddFileInfoField, isAddDataItem, insertAllFileInfoFieldList, updateAllFileInfoFieldList, insertAllMetadataEntityDataItemList, updateAllMetadataEntityDataItemList);
        } 
      } catch (Exception ex) {
        addImportInfoItemErrorLogDTO(dbColumnDTO, importFileInfoFieldParamDTO, ex);
        errorFields.add(dbColumnDTO.getColumnName());
        inEntityOrder--;
        recordRollBackItemsByException(tempFileInfoField, tempDataItem, isAddFileInfoField, isAddDataItem, insertFileInfoFieldList, updateFileInfoFieldList, insertMetadataEntityDataItemList, updateMetadataEntityDataItemList, insertAllFileInfoFieldList, updateAllFileInfoFieldList, insertAllMetadataEntityDataItemList, updateAllMetadataEntityDataItemList);
      } 
    } 
    if (!CollectionUtils.isEmpty(addMetadataEntityDataItemDTOList))
      this.dataStandardClient.batchAddMetadataEntityDataItemList(addMetadataEntityDataItemDTOList, importFileInfoFieldParamDTO.getPlatCode(), importFileInfoFieldParamDTO.getTokenId()); 
    getErrorStr(failFields, errorFields, errorSbStr);
    resultMap.put("insertFileInfoFieldList", insertFileInfoFieldList);
    resultMap.put("updateFileInfoFieldList", updateFileInfoFieldList);
    resultMap.put("insertMetadataEntityDataItemList", insertMetadataEntityDataItemList);
    resultMap.put("updateMetadataEntityDataItemList", updateMetadataEntityDataItemList);
    resultMap.put("insertAllFileInfoFieldList", insertAllFileInfoFieldList);
    resultMap.put("updateAllFileInfoFieldList", updateAllFileInfoFieldList);
    resultMap.put("insertAllMetadataEntityDataItemList", insertAllMetadataEntityDataItemList);
    resultMap.put("updateAllMetadataEntityDataItemList", updateAllMetadataEntityDataItemList);
    resultMap.put("errorSbStr", errorSbStr);
    return ResultEntity.successMessage(resultMap);
  }
  
  private void recoverAllErrorData(ImportFileInfoFieldParamDTO importParam, List<FileInfoFieldPO> insertFileInfoFieldList, List<FileInfoFieldPO> updateFileInfoFieldList, List<MetadataEntityDataItemVO> insertMetadataEntityDataItemList, List<MetadataEntityDataItemVO> updateMetadataEntityDataItemList, FileInfoTablePO entity, String tokenId) {
    recoverFileInfoFieldAndDataItemErrorData(insertFileInfoFieldList, updateFileInfoFieldList, insertMetadataEntityDataItemList, updateMetadataEntityDataItemList, importParam, entity, tokenId);
  }
  
  private void recoverFileInfoFieldAndDataItemErrorData(List<FileInfoFieldPO> insertFileInfoFieldList, List<FileInfoFieldPO> updateFileInfoFieldList, List<MetadataEntityDataItemVO> insertMetadataEntityDataItemList, List<MetadataEntityDataItemVO> updateMetadataEntityDataItemList, ImportFileInfoFieldParamDTO importParam, FileInfoTablePO entity, String tokenId) {
    IFileInfoFieldDao fileInfoFieldDao = (IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(importParam.getPlatCode(), IFileInfoFieldDao.class);
    List<Long> delDataItemIds = new ArrayList<>();
    List<Long> fileInfoFieldIds = new ArrayList<>();
    int i;
    for (i = 0; i < insertFileInfoFieldList.size(); i++) {
      ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(importParam.getPlatCode(), IFileInfoFieldDao.class)).deleteFileInfoField(((FileInfoFieldPO)insertFileInfoFieldList.get(i)).getFieldId());
      delDataItemIds.add(((MetadataEntityDataItemVO)insertMetadataEntityDataItemList.get(i)).getDataItemId());
    } 
    if (!delDataItemIds.isEmpty())
      this.dataStandardClient.deleteMetadataEntityDataItemByIds(delDataItemIds, importParam.getPlatCode(), tokenId); 
    for (i = 0; i < updateFileInfoFieldList.size(); i++)
      fileInfoFieldDao.updateFileInfoFieldSelective(updateFileInfoFieldList.get(i)); 
    for (i = 0; i < updateMetadataEntityDataItemList.size(); i++) {
      MetadataEntityDataItemDTO metadataEntityDataItemDTO = new MetadataEntityDataItemDTO();
      BeanUtils.copyProperties(updateMetadataEntityDataItemList.get(i), metadataEntityDataItemDTO);
      metadataEntityDataItemDTO.setIsDelete(DCConst.FALSE);
      this.dataStandardClient.updateMetadataEntityDataItemNotVerify(metadataEntityDataItemDTO, importParam.getPlatCode(), tokenId);
    } 
  }
  
  private Map<String, Object> saveFileInfoFieldFromImport(FileInfoFieldPO tempFileInfoField, DBColumnDTO dbColumnDTO, Integer inEntityOrder, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, FileInfoTablePO masterEntity, MetadataEntityDataItemVO tempDataItem, List<MetadataEntityDataItemDTO> addMetadataEntityDataItemDTOList) {
    int isPrimaryKey = (dbColumnDTO.getIsPrimaryKey() == null) ? 0 : dbColumnDTO.getIsPrimaryKey().intValue();
    String fieldCNName = (dbColumnDTO.getDescription() != null && dbColumnDTO.getDescription().length() > NAME_MAX_LENGTH) ? dbColumnDTO.getColumnName() : dbColumnDTO.getDescription();
    Boolean isAddFileInfoField = Boolean.valueOf(true);
    Boolean isAddDataItem = Boolean.valueOf(true);
    Map<String, Object> result = new HashMap<>();
    Date curDate = new Date();
    List<Long> standardWorkerIdList = importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().getWorkerIdList();
    if (tempFileInfoField == null) {
      String infoItemValue = StringUtils.isEmpty(fieldCNName) ? dbColumnDTO.getColumnName() : fieldCNName;
      tempFileInfoField = new FileInfoFieldPO();
      tempFileInfoField.setFieldId((Long)WorkerId.getNextId(Long.class));
      tempFileInfoField.setIsPrimaryKey(Integer.valueOf(isPrimaryKey));
      tempFileInfoField.setFileTableId(masterEntity.getFileTableId());
      tempFileInfoField.setFieldOrder(inEntityOrder);
      tempFileInfoField.setDataItemId(tempDataItem.getDataItemId());
      tempFileInfoField.setFieldCnName(infoItemValue);
      tempFileInfoField.setDescription(dbColumnDTO.getDescription());
      tempFileInfoField.setFieldStatus(DCConst.FileFieldStatus.VERIFY);
      tempFileInfoField.setUserId(importFileInfoFieldParamDTO.getUserId());
      tempFileInfoField.setOrganizationId(importFileInfoFieldParamDTO.getOrganizationId());
      tempFileInfoField.setIsReference(DCConst.FALSE);
      tempFileInfoField.setUpdateTime(curDate);
      tempFileInfoField.setFieldType(tempDataItem.getDataType());
      tempFileInfoField.setFieldLength(tempDataItem.getDataLength());
      tempFileInfoField.setFieldScale(tempDataItem.getDataScale());
      tempFileInfoField.setIsSystem(DCConst.FALSE);
      tempFileInfoField.setIsDelete(DCConst.FALSE);
      tempFileInfoField.setFieldName(dbColumnDTO.getColumnName());
      tempFileInfoField.setCreateTime(curDate);
      if (DCConst.TRUE.equals(dbColumnDTO.getIsNullAble())) {
        tempFileInfoField.setIsRequired(DCConst.FALSE);
      } else {
        tempFileInfoField.setIsRequired(DCConst.TRUE);
      } 
      MetadataEntityDataItemDTO metadataEntityDataItemDTO = new MetadataEntityDataItemDTO();
      BeanUtils.copyProperties(tempDataItem, metadataEntityDataItemDTO);
      metadataEntityDataItemDTO.setDataItemId((standardWorkerIdList.size() > 0) ? standardWorkerIdList.remove(0) : (Long)WorkerId.getNextId(Long.class));
      addMetadataEntityDataItemDTOList.add(metadataEntityDataItemDTO);
      tempFileInfoField.setDataItemId(metadataEntityDataItemDTO.getDataItemId());
      changeRepeatFieldCnName(tempFileInfoField);
      ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(importFileInfoFieldParamDTO.getPlatCode(), IFileInfoFieldDao.class)).insertFileInfoField(tempFileInfoField);
      Integer integer1 = inEntityOrder, integer2 = inEntityOrder = Integer.valueOf(inEntityOrder.intValue() + 1);
    } else {
      isAddFileInfoField = Boolean.valueOf(false);
      tempFileInfoField.setIsPrimaryKey(Integer.valueOf(isPrimaryKey));
      tempFileInfoField.setFieldCnName(StringUtils.isEmpty(tempFileInfoField.getFieldCnName()) ? tempDataItem.getDataItemCnName() : tempFileInfoField.getFieldCnName());
      tempFileInfoField.setDescription(StringUtils.isEmpty(tempFileInfoField.getDescription()) ? tempDataItem.getDescription() : tempFileInfoField.getDescription());
      tempFileInfoField.setFieldStatus(DCConst.FileFieldStatus.VERIFY);
      tempFileInfoField.setIsRequired(Integer.valueOf(isPrimaryKey));
      if (tempFileInfoField.getDataItemId() == null) {
        MetadataEntityDataItemDTO metadataEntityDataItemDTO = new MetadataEntityDataItemDTO();
        BeanUtils.copyProperties(tempDataItem, metadataEntityDataItemDTO);
        metadataEntityDataItemDTO.setDataItemId((standardWorkerIdList.size() > 0) ? standardWorkerIdList.remove(0) : (Long)WorkerId.getNextId(Long.class));
        addMetadataEntityDataItemDTOList.add(metadataEntityDataItemDTO);
        tempFileInfoField.setDataItemId(metadataEntityDataItemDTO.getDataItemId());
      } else {
        isAddDataItem = Boolean.valueOf(false);
        MetadataEntityDataItemDTO metadataEntityDataItemDTO = new MetadataEntityDataItemDTO();
        BeanUtils.copyProperties(tempDataItem, metadataEntityDataItemDTO);
        metadataEntityDataItemDTO.setDataItemId((standardWorkerIdList.size() > 0) ? standardWorkerIdList.remove(0) : (Long)WorkerId.getNextId(Long.class));
        addMetadataEntityDataItemDTOList.add(metadataEntityDataItemDTO);
      } 
      tempFileInfoField.setFieldStatus(DCConst.InfoItemStatus.VERIFY);
      tempFileInfoField.setUpdateTime(curDate);
      changeRepeatFieldCnName(tempFileInfoField);
      ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(importFileInfoFieldParamDTO.getPlatCode(), IFileInfoFieldDao.class)).updateFileInfoFieldSelective(tempFileInfoField);
    } 
    result.put("isAddFileInfoField", isAddFileInfoField);
    result.put("isAddDataItem", isAddDataItem);
    result.put("inEntityOrder", inEntityOrder);
    return result;
  }
  
  private void changeRepeatFieldCnName(FileInfoFieldPO fileInfoFieldPO) {
    List<FileInfoFieldPO> fileInfoFieldPOList = ((IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(getDefaultCode(), IFileInfoFieldDao.class)).selectFileInfoFieldsByFileTableId(fileInfoFieldPO.getFileTableId());
    if (!CollectionUtils.isEmpty(fileInfoFieldPOList) && !StringUtils.isEmpty(fileInfoFieldPO.getFieldCnName())) {
      List<String> fieldNameList = (List<String>)fileInfoFieldPOList.stream().filter(f -> !f.getFieldId().equals(fileInfoFieldPO.getFieldId())).map(FileInfoFieldPO::getFieldCnName).collect(Collectors.toList());
      int repeatStrCount = StringUtil.getRepeatStrCount(fieldNameList, fileInfoFieldPO.getFieldCnName());
      if (repeatStrCount > 0)
        fileInfoFieldPO.setFieldCnName(fileInfoFieldPO.getFieldCnName() + "(" + repeatStrCount + ")"); 
    } 
  }
  
  private void recordRollBackItemsByException(FileInfoFieldPO tempFileInfoField, MetadataEntityDataItemVO tempDataItem, Boolean isAddFileInfoField, Boolean isAddDataItem, List<FileInfoFieldPO> insertFileInfoFieldList, List<FileInfoFieldPO> updateFileInfoFieldList, List<MetadataEntityDataItemVO> insertMetadataEntityDataItemList, List<MetadataEntityDataItemVO> updateMetadataEntityDataItemList, List<FileInfoFieldPO> insertAllFileInfoFieldList, List<FileInfoFieldPO> updateAllFileInfoFieldList, List<MetadataEntityDataItemVO> insertAllMetadataEntityDataItemList, List<MetadataEntityDataItemVO> updateAllMetadataEntityDataItemList) {
    if (tempFileInfoField != null)
      if (isAddFileInfoField.booleanValue()) {
        insertFileInfoFieldList.add(tempFileInfoField);
        insertAllFileInfoFieldList.add(tempFileInfoField);
      } else {
        updateFileInfoFieldList.add(tempFileInfoField);
        updateAllFileInfoFieldList.add(tempFileInfoField);
      }  
    if (tempDataItem != null)
      if (isAddDataItem.booleanValue()) {
        insertMetadataEntityDataItemList.add(tempDataItem);
        insertAllMetadataEntityDataItemList.add(tempDataItem);
      } else {
        updateMetadataEntityDataItemList.add(tempDataItem);
        updateAllMetadataEntityDataItemList.add(tempDataItem);
      }  
  }
  
  private void recordRollBackItems(FileInfoFieldPO tempInfoItem, MetadataEntityDataItemVO tempDataItem, Boolean isAddInfoItem, Boolean isAddDataItem, List<FileInfoFieldPO> insertAllFileInfoFieldList, List<FileInfoFieldPO> updateAllFileInfoFieldList, List<MetadataEntityDataItemVO> insertAllMetadataEntityDataItemList, List<MetadataEntityDataItemVO> updateAllMetadataEntityDataItemList) {
    if (tempInfoItem != null)
      if (isAddInfoItem.booleanValue()) {
        insertAllFileInfoFieldList.add(tempInfoItem);
      } else {
        updateAllFileInfoFieldList.add(tempInfoItem);
      }  
    if (tempDataItem != null)
      if (isAddDataItem.booleanValue()) {
        insertAllMetadataEntityDataItemList.add(tempDataItem);
      } else {
        updateAllMetadataEntityDataItemList.add(tempDataItem);
      }  
  }
  
  private void addImportInfoItemErrorLogDTO(DBColumnDTO dbColumnDTO, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, Exception ex) {
    ErrorLogDTO logDTO = new ErrorLogDTO();
    logDTO.setMsg("根据列'{" + dbColumnDTO.getColumnName() + "}'导入文件表字段失败");
    logDTO.setPlatCode(importFileInfoFieldParamDTO.getPlatCode());
    logDTO.setTokenId(importFileInfoFieldParamDTO.getTokenId());
    logDTO.setStackInfo(ExceptionUtil.getStackTraceMsg(ex));
    DCLogHelper.error(logDTO);
  }
  
  private void getErrorStr(List<String> failFields, List<String> errorFields, StringBuilder errorSbStr) {
    if (!failFields.isEmpty())
      for (int i = 0; i < failFields.size(); i++) {
        if (!errorFields.contains(failFields.get(i)))
          errorFields.add(failFields.get(i)); 
      }  
    if (!errorFields.isEmpty()) {
      String str = StringUtils.join(errorFields, "、");
      errorSbStr.append("根据列【" + str + "】导入文件表字段失败");
    } 
  }
  
  private ResultEntity<Map<String, Object>> getAddFileInfoFieldAndDataItem(DBColumnDTO dbColumnDTO, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, DataSourceVO dataSourceVO, List<FileInfoFieldPO> fileInfoFieldPOList, List<MetadataEntityDataItemVO> metadataEntityDataItemPOList) throws Exception {
    Map<String, Object> result = new HashMap<>();
    FileInfoFieldPO tempFileInfoField = null;
    MetadataEntityDataItemVO tempDataItem = null;
    MetadataTypeVO tempMetadataType = null;
    String fieldName = dbColumnDTO.getColumnName();
    String dataTypeName = dbColumnDTO.getDataType();
    String fieldComment = dbColumnDTO.getDescription();
    Integer dataLength = dbColumnDTO.getDataLength();
    Integer dataScale = dbColumnDTO.getScale();
    String fieldCNName = (fieldComment != null && fieldComment.length() > NAME_MAX_LENGTH) ? fieldName : fieldComment;
    Integer maxNvarcharLength = Integer.valueOf(4000);
    Integer defaultBigintLength = Integer.valueOf(20);
    if ("nvarchar".equals(dataTypeName) && dataLength.intValue() == -1)
      dataLength = maxNvarcharLength; 
    if ("bigint".equals(dataTypeName) && dataLength == null)
      dataLength = defaultBigintLength; 
    tempDataItem = new MetadataEntityDataItemVO();
    tempDataItem.setDataItemId((Long)WorkerId.getNextId(Long.class));
    tempDataItem.setDataLength(dataLength);
    tempDataItem.setDataScale(dataScale);
    tempDataItem.setDescription(fieldComment);
    tempDataItem.setDataItemCnName(fieldCNName);
    tempDataItem.setDataItemName(fieldName);
    tempDataItem.setDataType("String");
    tempDataItem.setUserId(importFileInfoFieldParamDTO.getUserId());
    tempDataItem.setOrganizationId(importFileInfoFieldParamDTO.getOrganizationId());
    tempDataItem.setDataItemType("0");
    tempDataItem.setIsDelete(Integer.valueOf(0));
    if (DCConst.TRUE.equals(dbColumnDTO.getIsNullAble())) {
      tempDataItem.setIsRequired(DCConst.FALSE);
    } else {
      tempDataItem.setIsRequired(DCConst.TRUE);
    } 
    MetadataTypeParamDTO metadataTypeParamDTO = new MetadataTypeParamDTO();
    metadataTypeParamDTO.setScale(dataScale);
    metadataTypeParamDTO.setLength(dataLength);
    metadataTypeParamDTO.setDbDataTypeName(dataTypeName);
    metadataTypeParamDTO.setDbType(dataSourceVO.getType());
    tempMetadataType = getMetadataTypeByDbDataTypeName(metadataTypeParamDTO, importFileInfoFieldParamDTO);
    if (tempMetadataType != null)
      tempDataItem.setDataType(tempMetadataType.getDataTypeName()); 
    ResultEntity<Map<String, Object>> getInfoItemRet = getInfoItemPOFromPlat(fileInfoFieldPOList, fieldName);
    if (Objects.equals(getInfoItemRet.getCode(), Integer.valueOf(0)) && getInfoItemRet.getObj() != null) {
      tempFileInfoField = (FileInfoFieldPO)getInfoItemRet.getObj();
    } else if (!Objects.equals(getInfoItemRet.getCode(), Integer.valueOf(0))) {
      return getInfoItemRet;
    } 
    result.put("tempFileInfoField", tempFileInfoField);
    result.put("tempDataItem", tempDataItem);
    return ResultEntity.successMessage(result);
  }
  
  private ResultEntity getInfoItemPOFromPlat(List<FileInfoFieldPO> fileInfoFieldPOList, String fieldName) {
    FileInfoFieldPO tempFileInfoField = null;
    fieldName = StringUtils.hasText(fieldName) ? fieldName : "";
    for (int j = 0; j < fileInfoFieldPOList.size(); j++) {
      FileInfoFieldPO fileInfoField = fileInfoFieldPOList.get(j);
      if (fieldName.equalsIgnoreCase(fileInfoField.getFieldName()))
        tempFileInfoField = fileInfoField; 
    } 
    ResultEntity result = ResultEntity.successMessage(tempFileInfoField);
    return result;
  }
  
  private MetadataTypeVO getMetadataTypeByDbDataTypeName(MetadataTypeParamDTO metadataTypeParamDTO, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO) {
    List<MetadataTypeVO> metadataTypeList = importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().getMetadataTypeList();
    if (metadataTypeList == null) {
      ResultEntity<List<MetadataTypeVO>> metadataTypeListRt = this.dataStandardClient.getMetadataTypeList(importFileInfoFieldParamDTO.getPlatCode(), importFileInfoFieldParamDTO.getTokenId());
      if (metadataTypeListRt.getCode().intValue() == 0 && metadataTypeListRt.getObj() != null) {
        metadataTypeList = (List<MetadataTypeVO>)metadataTypeListRt.getObj();
        importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().setMetadataTypeList(metadataTypeList);
      } else {
        return null;
      } 
    } 
    List<MetadataTypeVO> tempMetadataTypePOList = new ArrayList<>();
    for (MetadataTypeVO metadataType : metadataTypeList) {
      String[] mapping = new String[0];
      switch (metadataTypeParamDTO.getDbType()) {
        case "mysql":
          mapping = metadataType.getMysqlDbMapping().split(",");
          break;
        case "sqlserver":
          mapping = metadataType.getSqlDbMapping().split(",");
          break;
        case "oracle":
          mapping = metadataType.getOracleDbMapping().split(",");
          break;
        case "postgresql":
          mapping = metadataType.getPgsqlDbMapping().split(",");
          break;
        case "dm":
          mapping = metadataType.getDm8DbMapping().split(",");
          break;
        case "kingbase":
          mapping = metadataType.getKingBaseDbMapping().split(",");
          break;
      } 
      if (Arrays.<String>stream(mapping).anyMatch(item -> item.equalsIgnoreCase(metadataTypeParamDTO.getDbDataTypeName())))
        tempMetadataTypePOList.add(metadataType); 
    } 
    MetadataTypeVO metadataTypeVO = null;
    int length = 10;
    if (CollectionUtils.isEmpty(tempMetadataTypePOList)) {
      LogHelper.error(metadataTypeParamDTO.getDbDataTypeName() + "没有找到[" + metadataTypeParamDTO.getDbType() + "]对应的类型： " + JSON.toJSONString(metadataTypeList));
      return null;
    } 
    if (tempMetadataTypePOList.size() == 1)
      return tempMetadataTypePOList.get(0); 
    if (tempMetadataTypePOList.size() > 1)
      if ((metadataTypeParamDTO.getLength() != null && (metadataTypeParamDTO.getLength().intValue() == 0 || metadataTypeParamDTO.getLength().intValue() == 10)) || (metadataTypeParamDTO.getScale() != null && metadataTypeParamDTO
        .getScale().intValue() == 0)) {
        metadataTypeVO = tempMetadataTypePOList.stream().filter(item -> item.getDataTypeName().equalsIgnoreCase("Int")).findFirst().orElse(null);
      } else {
        metadataTypeVO = tempMetadataTypePOList.stream().filter(item -> item.getDataTypeName().equalsIgnoreCase("Numeric")).findFirst().orElse(null);
      }  
    return metadataTypeVO;
  }
  
  private ResultEntity importFileInfoFieldException(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, String tokenId, String stackTraceMsg) {
    ErrorLogDTO logDTO = new ErrorLogDTO();
    logDTO.setMsg("导入文件表方法importFileInfoField失败");
    logDTO.setPlatCode(importFileInfoFieldParamDTO.getPlatCode());
    logDTO.setTokenId(tokenId);
    logDTO.setStackInfo(stackTraceMsg);
    DCLogHelper.error(logDTO);
    return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_IMPORT_FILE_INFO_FIELD_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_IMPORT_FILE_INFO_FIELD_FAILED.getMessage());
  }
  
  private ResultEntity isExistTable(DataStructProvider dataStructProvider, DataSourceVO dataSourceVO, String fileInfoTableName) {
    if (dataSourceVO != null && !StringUtil.isEmpty(fileInfoTableName)) {
      Boolean isExistsTable = dataStructProvider.isExistsTable(fileInfoTableName);
      if (!isExistsTable.booleanValue())
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ROLL_BACK_ITEMS_BY_IMPORT_FAILED.getCode()), "导入文件表字段失败,原因: 文件表【" + fileInfoTableName + "】不存在"); 
    } 
    return null;
  }
  
  private void initStandardClientWorkerIdList(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, int count) {
    if (count == 0)
      return; 
    ResultEntity<List<Long>> workerIdListRt = this.dataStandardClient.getWorkerIdList(Integer.valueOf(count));
    if (workerIdListRt.getCode().intValue() == 0)
      importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().setWorkerIdList((List)workerIdListRt.getObj()); 
  }
  
  private boolean isNeedImport(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, DBColumnDTO dbColumnDTO) throws Exception {
    if (Character.isWhitespace(dbColumnDTO.getColumnName().charAt(0)))
      throw new Exception("字段名称不能以空字符串开头"); 
    if (!SysFieldHelper.getFileSysFieldName(FileSysFieldEnum.DBID).equalsIgnoreCase(dbColumnDTO.getColumnName()) && importFileInfoFieldParamDTO.getImportFieldList()
      .containsKey(dbColumnDTO.getColumnName()) && SysFieldHelper.fileSysFieldContains(dbColumnDTO.getColumnName().toLowerCase()) && DCConst.TRUE.equals(dbColumnDTO.getIsPrimaryKey()))
      throw new Exception("物理字段名称【" + dbColumnDTO.getColumnName() + "】为主键时不能和文件表内置字段相同"); 
    if (Objects.equals(importFileInfoFieldParamDTO.getPlatCode(), "Manage") && 
      !importFileInfoFieldParamDTO.getImportFieldList().containsKey(dbColumnDTO.getColumnName()))
      return false; 
    if (Objects.equals(importFileInfoFieldParamDTO.getPlatCode(), "Collection") && 
      !importFileInfoFieldParamDTO.getImportFieldList().containsKey(dbColumnDTO.getColumnName()))
      return false; 
    return true;
  }
  
  private ResultEntity<List<DBColumnDTO>> getColumnDTOList(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO, DataStructProvider dataStructProvider, DataSourceVO dataSourceVO) {
    String importTableName = importFileInfoFieldParamDTO.getTableName();
    Boolean isExistTable = dataStructProvider.isExistsTable(importTableName);
    if (!isExistTable.booleanValue())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ROLL_BACK_ITEMS_BY_IMPORT_FAILED.getCode()), "导入文件表字段失败,原因:【" + importTableName + "】表不存在"); 
    List<DBColumnDTO> dbColumnDTOList = (List<DBColumnDTO>)importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().getColumnListMap().get(dataSourceVO.getId() + "_" + importTableName);
    if (dbColumnDTOList == null)
      dbColumnDTOList = dataStructProvider.getEntityDbTableStruct(importTableName, null); 
    if (dbColumnDTOList == null || dbColumnDTOList.isEmpty())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_GET_TABLE_STRUCTURE_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_GET_TABLE_STRUCTURE_FAILED.getMessage()); 
    return ResultEntity.successMessage(dbColumnDTOList);
  }
  
  private DataSourceVO getDataSourcePO(ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO) {
    Map<Long, DataSourceVO> dataSourceMap = importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().getDataSourceMap();
    DataSourceVO dataSourceVO = null;
    if (dataSourceMap.containsKey(importFileInfoFieldParamDTO.getDataSourceId())) {
      dataSourceVO = dataSourceMap.get(importFileInfoFieldParamDTO.getDataSourceId());
    } else if (importFileInfoFieldParamDTO.getDataSourceId() != null) {
      dataSourceVO = (DataSourceVO)this.dataStandardClient.getDataSourceInfoDoNotDecryptById(importFileInfoFieldParamDTO.getDataSourceId(), importFileInfoFieldParamDTO.getPlatCode(), importFileInfoFieldParamDTO.getTokenId()).getObj();
      if (dataSourceVO != null)
        dataSourceMap.put(importFileInfoFieldParamDTO.getDataSourceId(), dataSourceVO); 
    } 
    return dataSourceVO;
  }
  
  private ResultEntity<DataStructProvider> getDataStructProvider(DataSourceVO dataSourceVO, ImportFileInfoFieldParamDTO importFileInfoFieldParamDTO) {
    Map<Long, DataStructProvider> providerMap = importFileInfoFieldParamDTO.getImportFieldLocalParamDTO().getProviderMap();
    if (providerMap.containsKey(importFileInfoFieldParamDTO.getDataSourceId()))
      return ResultEntity.successMessage(providerMap.get(importFileInfoFieldParamDTO.getDataSourceId())); 
    DataSourceDTO dataSourceDTO = new DataSourceDTO();
    BeanUtils.copyProperties(dataSourceVO, dataSourceDTO);
    ResultEntity<DataStructProvider> dataBaseProviderRt = DataStructProvider.getDataBaseProvider(dataSourceDTO);
    if (dataBaseProviderRt.getCode().intValue() == 0)
      providerMap.put(importFileInfoFieldParamDTO.getDataSourceId(), DataStructProvider.getDataBaseProvider(dataSourceDTO).getObj()); 
    return dataBaseProviderRt;
  }
}
